VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "COMCTL32.OCX"
Begin VB.Form Form1 
   Caption         =   "Buch"
   ClientHeight    =   4965
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5295
   LinkTopic       =   "Form1"
   ScaleHeight     =   4965
   ScaleWidth      =   5295
   StartUpPosition =   3  'Windows Default
   Begin ComctlLib.TreeView tvInhalt 
      Height          =   4815
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   5175
      _ExtentX        =   9128
      _ExtentY        =   8493
      _Version        =   327682
      Style           =   7
      Appearance      =   1
   End
   Begin VB.Menu mnuFile 
      Caption         =   "Datei"
      Begin VB.Menu mnuFileCmd 
         Caption         =   "Neues Kapitel"
         Index           =   0
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileCmd 
         Caption         =   "Umbenennen"
         Index           =   1
         Shortcut        =   {F2}
      End
      Begin VB.Menu mnuFileCmd 
         Caption         =   "Lschen"
         Index           =   2
         Shortcut        =   ^C
      End
      Begin VB.Menu mnuFile0 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileQuit 
         Caption         =   "B&eenden"
         Shortcut        =   ^X
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Darstellung eines Buch-Kapitelhierarchie in einem Treeview Control.

' (c) 1998 by Ralf Westphal fr BasicPro


Option Explicit


Private m_inhaltsverzeichnis As kapitel



Private Sub Form_Load()
    tvInhalt.Nodes.Add , , "root", "Inhaltsverzeichnis"
    
    With New Buch
        .Connect App.Path & "\buch.mdb"
        Set m_inhaltsverzeichnis = .Inhaltsverzeichnis
    End With
    
    loadChildren "root", m_inhaltsverzeichnis, True
        ' hier kann entschieden werden, ob nur die oberste Kapitelebene
        ' oder die gesamte Hierarchie geladen werden soll. Eine rekursive
        ' Anzeige (True) bentigt mehr Zeit, da aus der Datenbank alle
        ' Kapitel und Unterkapitel nacheinander herausgeholt werden.
        ' Ohne den dritten Parameter (oder mit False) wird jedem Kapitel
        ' immer nur ein Platzhalter fr evtl. vorhandene Unterkapitel
        ' untergeordnet. Erst im tvInhalt_Expand() Event prft das Programm,
        ' ob berhaupt Unterkapitel vorliegen.
    
    tvInhalt.Nodes("root").Expanded = True
End Sub



Private Sub mnuFile_Click()
    Dim isRootSelected As Boolean
    
    mnuFileCmd(0).Enabled = Not tvInhalt.SelectedItem Is Nothing
    
    If Not tvInhalt.SelectedItem Is Nothing Then isRootSelected = tvInhalt.SelectedItem.Key = "root"
    
    mnuFileCmd(1).Enabled = mnuFileCmd(0).Enabled And Not isRootSelected
    mnuFileCmd(2).Enabled = mnuFileCmd(1).Enabled
End Sub


Private Sub mnuFileCmd_Click(index As Integer)
    Select Case index
        Case 0  ' hinzufgen
            Dim newKapitel As kapitel
            
            ' garantieren, da alle Unterkapitel sichtbar sind. Erst dann
            ' kann spter der neue Eintrag auch angefgt werden
            If Not tvInhalt.SelectedItem.Expanded Then tvInhalt_Expand tvInhalt.SelectedItem
            
            ' 1. Datenmodell
            If tvInhalt.SelectedItem.Key = "root" Then
                Set newKapitel = m_inhaltsverzeichnis.Add("Neues Kapitel")
            Else
                Set newKapitel = FindKapitel(tvInhalt.SelectedItem).Add("Neues Kapitel")
            End If
            
            ' 2. User Interface
            Set tvInhalt.SelectedItem = tvInhalt.Nodes.Add(tvInhalt.SelectedItem.Key, tvwChild, newKapitel.OID, newKapitel.berschrift)
            tvInhalt.StartLabelEdit
            
        Case 1  ' umbenennen
            ' 1. User Interface
            tvInhalt.StartLabelEdit
            
            ' Das Datenmodell wird erst in tvInhalt_AfterLabelEdit() aktualisiert.
            
        Case 2  ' lschen
            ' 1. Datenmodell
            If tvInhalt.SelectedItem.Parent.Key = "root" Then
                ' Kapitel der obersten Ebene
                m_inhaltsverzeichnis.Remove tvInhalt.SelectedItem.Key
            Else
                ' Kapitel irgendwo in der Hierarchie
                FindKapitel(tvInhalt.SelectedItem.Parent).Remove tvInhalt.SelectedItem.Key
            End If
            
            ' 2. User Interface
            tvInhalt.Nodes.Remove tvInhalt.SelectedItem.Key
    End Select
End Sub


Private Sub mnuFileQuit_Click()
    Unload Me
End Sub



Private Sub tvInhalt_AfterLabelEdit(Cancel As Integer, NewString As String)
    ' 2. Datenmodell
    With FindKapitel(tvInhalt.SelectedItem)
        .berschrift = NewString
    End With
End Sub


Private Sub tvInhalt_BeforeLabelEdit(Cancel As Integer)
    Cancel = tvInhalt.SelectedItem.Key = "root"
End Sub


Private Sub tvInhalt_Expand(ByVal node As ComctlLib.node)
    If node.Children = 0 Then Exit Sub
    
    If Left$(node.Child.Key, 1) = "#" Then
        tvInhalt.Nodes.Remove node.Child.Key
        loadChildren node.Key, FindKapitel(node)
    End If
End Sub


Private Sub tvInhalt_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Button = 2 Then
        PopupMenu mnuFile
    End If
End Sub



'---------------------------------------------------------------------
' Unterkapitel zu einem Kapitel im Baum anzeigen

Private Sub loadChildren(ByVal parentOID As String, ByVal kapitel As kapitel, Optional ByVal useRecursion As Boolean = False)
    Dim i%
    For i = 1 To kapitel.Count
        With kapitel(i)
            With tvInhalt.Nodes.Add(parentOID, tvwChild, .OID, .berschrift)
                If useRecursion Then
                    ' rekursiv auch in die Unterkapitel hineingehen
                    loadChildren .Key, kapitel(i), True
                Else
                    ' Unterkapitel spter bei Bedarf nachladen
                    tvInhalt.Nodes.Add .Key, tvwChild, "#" & .Key, ""
                        ' ein "#" an erster Stelle sagt, da der Node
                        ' nur ein Platzhalter fr die noch nicht geladenen
                        ' Unterkapitel ist
                End If
            End With
        End With
    Next
End Sub


'------------------------------------------------------------------------
' Ein Kapitel zu einem Baumknoten finden.
' Aufsuchen erfolgt rekursiv den Pfad des Kapitels entlang (User Interface)
' im Baum hinauf und anschlieend in der Kapitelhierarchie (Datenmodell)
' wieder hinab.
' So vermeiden wir, im Datenmodell einen Verweise auf Parent-Objekte mitfhren
' zu mssen.
Private Function FindKapitel(ByVal node As node) As kapitel
    If node.Parent.Key = "root" Then
        Set FindKapitel = m_inhaltsverzeichnis(node.Key)
    Else
        Set FindKapitel = FindKapitel(node.Parent).Item(node.Key)
    End If
End Function

