VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Kapitel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Objekt, welches ein Kapitel in einem Buch reprsentiert inkl. seiner
' Unterkapitel (Businessobject-Tier)

' (c) 1998 by Ralf Westphal fr BasicPro

Option Explicit


Private m_db As DBAccess

Private m_OID As String
Private m_berschrift As String

Private m_Unterkapitel As Collection



'----------------------------------------------------------------------
' Konstruktoren

' Initialisierung der obersten Kapitelebene
Friend Sub CreateRoot(ByVal db As DBAccess)
    Set m_db = db
End Sub


' Initialisierung eines neuen Kapitels
Friend Sub CreateNew(ByVal db As DBAccess, ByVal parentOID As String, ByVal berschrift As String)
    Set m_db = db
    
    m_OID = m_db.Add(parentOID, berschrift)
    m_berschrift = berschrift
    
    Set m_Unterkapitel = Nothing
End Sub


' Initialisierung eines existierenden Kapitels aus einem DB-Datensatz
Friend Sub CreateFromDB(ByVal db As DBAccess, ByVal kapitel As Variant, ByVal index As Integer)
    Set m_db = db
    
    m_OID = kapitel(0, index)
    m_berschrift = kapitel(2, index)
    
    ' die Unterkapitel dieses Kapitels werden erst bei Bedarf nachgeladen
    Set m_Unterkapitel = Nothing
End Sub



'---------------------------------------------------------------
' Eigenschaften eines Kapitels

Public Property Get OID() As String
    OID = m_OID
End Property



Public Property Get berschrift() As String
    berschrift = m_berschrift
End Property

Public Property Let berschrift(ByVal newberschrift As String)
    m_berschrift = newberschrift
    
    m_db.Update m_OID, newberschrift
End Property



'-------------------------------------------------------------------
' Methoden zu Unterkapiteln dieses Kapitels

Public Property Get Count() As Integer
    Count = Unterkapitel.Count
End Property


Public Property Get Item(ByVal index) As kapitel
Attribute Item.VB_UserMemId = 0
    Set Item = Unterkapitel(index)
End Property


Public Sub Remove(ByVal index)
    m_db.Remove Unterkapitel.Item(index).OID
    Unterkapitel.Remove index
End Sub


Public Function Add(ByVal berschrift As String) As kapitel
    Dim newKapitel As New kapitel
    
    newKapitel.CreateNew m_db, m_OID, berschrift
    On Error Resume Next
    Unterkapitel.Add newKapitel, newKapitel.OID
    
    Set Add = newKapitel
End Function



'------------------------------------------------------------------------
' Unterkapitel transparent laden, wenn das erste Mal auf sie
' zugegriffen wird

Private Property Get Unterkapitel() As Collection
    If m_Unterkapitel Is Nothing Then
        Set m_Unterkapitel = New Collection
                
        Dim kapitelliste, kapitel As kapitel
        kapitelliste = m_db.Load(m_OID, True)
        If Not IsNull(kapitelliste) Then
            Dim i%
            For i = 0 To UBound(kapitelliste, 2)
                Set kapitel = New kapitel
                kapitel.CreateFromDB m_db, kapitelliste, i
                m_Unterkapitel.Add kapitel, kapitel.OID
            Next
        End If
        
    End If
    
    Set Unterkapitel = m_Unterkapitel
End Property
